/*
 * @file list.c
 *
 * This is the implementation of the list module.
 */

#include <stdlib.h>
#include <stdio.h>

#include "list.h"

void*
xmalloc(size_t size)
{
    void *p = malloc(size);
    if (! p) {
	perror("malloc()");
	exit(1);
    }
    return p;
}

struct list*
push_front(struct list *my_list , int  value)
{
    struct list *newel;
    
    newel = (struct list *) xmalloc(sizeof(struct list));
    newel->info = value;
    newel->next = my_list;
    return  newel;
}

struct list*
push_back(struct list* my_list , int  value)
{
    struct list *cursor , *newel;
    cursor = my_list;

    newel = (struct list *) xmalloc(sizeof(struct list));
    newel ->info = value;
    newel ->next = NULL;
	
    if (my_list == NULL) {
	return newel;
    }

    for (cursor = my_list; cursor->next != NULL; cursor = cursor->next) ;
    cursor ->next = newel;
    return  my_list;
}


/*
 * Disposes a previously allocated list.
 */

void
dispose_list(struct list* my_list)
{
    struct list *nextelem;

    while (my_list  != NULL) {
	nextelem = my_list ->next;
	free(my_list);
	my_list = nextelem;
    }
}

void
print_list(struct list* my_list)
{
    struct list *p;

    for (p = my_list; p != NULL; p = p->next) {
	printf("%d\n", p->info);
    }
}

void
foreach_list_simple(struct list *my_list, void (*func)(int num))
{
    struct list *p;

    for (p = my_list; p != NULL; p = p->next) {
	func(p->info);
    }
}

void
foreach_list(struct list *my_list,
	     void (*func)(int num, void *state),
	     void *state)
{
    struct list *p;

    for (p = my_list; p != NULL; p = p->next) {
	func(p->info, state);
    }
}
